AWS IoT Device SDK C++ v2: Aws::Iotsecuretunneling::SecureTunnel Class Reference

AWS IoT Device SDK C++ v2 1.14.0 AWS IoT Device SDK C++ v2

Public Member Functions | Friends | List of all members
Aws::Iotsecuretunneling::SecureTunnel Class Referencefinal

`#include <SecureTunnel.h>`

## Public Member Functions
| SecureTunnel (Crt::Allocator *allocator, Aws::Crt::Io::ClientBootstrap *clientBootstrap, const Aws::Crt::Io::SocketOptions &socketOptions, const std::string &accessToken, aws_secure_tunneling_local_proxy_mode localProxyMode, const std::string &endpointHost, const std::string &rootCa, OnConnectionComplete onConnectionComplete, OnConnectionShutdown onConnectionShutdown, OnSendDataComplete onSendDataComplete, OnDataReceive onDataReceive, OnStreamStart onStreamStart, OnStreamReset onStreamReset, OnSessionReset onSessionReset)
| SecureTunnel (const SecureTunnel &)=delete
| SecureTunnel (SecureTunnel &&) noexcept
virtual | ~SecureTunnel ()
SecureTunnel & | operator= (const SecureTunnel &)=delete
SecureTunnel & | operator= (SecureTunnel &&) noexcept
bool | IsValid ()
int | Connect ()
int | Close ()
int | SendData (const Crt::ByteCursor &data)
int | SendStreamStart ()
int | SendStreamReset ()
aws_secure_tunnel * | GetUnderlyingHandle ()

## Friends
class | SecureTunnelBuilder

## Constructor & Destructor Documentation

## ◆ SecureTunnel() [1/3]

Aws::Iotsecuretunneling::SecureTunnel::SecureTunnel | ( | Crt::Allocator * | allocator,
|  | Aws::Crt::Io::ClientBootstrap * | clientBootstrap,
|  | const Aws::Crt::Io::SocketOptions & | socketOptions,
|  | const std::string & | accessToken,
|  | aws_secure_tunneling_local_proxy_mode | localProxyMode,
|  | const std::string & | endpointHost,
|  | const std::string & | rootCa,
|  | OnConnectionComplete | onConnectionComplete,
|  | OnConnectionShutdown | onConnectionShutdown,
|  | OnSendDataComplete | onSendDataComplete,
|  | OnDataReceive | onDataReceive,
|  | OnStreamStart | onStreamStart,
|  | OnStreamReset | onStreamReset,
|  | OnSessionReset | onSessionReset
| ) |  |

Should be deprecated when possible. SecureTunnelBuilder::Build() should be used to generate new SecureTunnels

## ◆ SecureTunnel() [2/3]

Aws::Iotsecuretunneling::SecureTunnel::SecureTunnel | ( | const SecureTunnel & |  | ) |
| delete

## ◆ SecureTunnel() [3/3]

Aws::Iotsecuretunneling::SecureTunnel::SecureTunnel | ( | SecureTunnel && | other | ) |
| noexcept

## ◆ ~SecureTunnel()

Aws::Iotsecuretunneling::SecureTunnel::~SecureTunnel | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ Close()

int Aws::Iotsecuretunneling::SecureTunnel::Close | ( |  | ) |

## ◆ Connect()

int Aws::Iotsecuretunneling::SecureTunnel::Connect | ( |  | ) |

## ◆ GetUnderlyingHandle()

aws_secure_tunnel * Aws::Iotsecuretunneling::SecureTunnel::GetUnderlyingHandle | ( |  | ) |

## ◆ IsValid()

bool Aws::Iotsecuretunneling::SecureTunnel::IsValid | ( |  | ) |

## ◆ operator=() [1/2]

SecureTunnel & Aws::Iotsecuretunneling::SecureTunnel::operator= | ( | const SecureTunnel & |  | ) |
| delete

## ◆ operator=() [2/2]

SecureTunnel & Aws::Iotsecuretunneling::SecureTunnel::operator= | ( | SecureTunnel && | other | ) |
| noexcept

## ◆ SendData()

int Aws::Iotsecuretunneling::SecureTunnel::SendData | ( | const Crt::ByteCursor & | data | ) |

## ◆ SendStreamReset()

int Aws::Iotsecuretunneling::SecureTunnel::SendStreamReset | ( |  | ) |

## ◆ SendStreamStart()

int Aws::Iotsecuretunneling::SecureTunnel::SendStreamStart | ( |  | ) |

## Friends And Related Function Documentation

## ◆ SecureTunnelBuilder

friend class SecureTunnelBuilder
| friend

The documentation for this class was generated from the following files:

- secure_tunneling/include/aws/iotsecuretunneling/SecureTunnel.h
- secure_tunneling/source/SecureTunnel.cpp